package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LinePreScript struct {
	service.Service
}

// GetPage 获取LinePreScript列表
func (e *LinePreScript) GetPage(c *dto.LinePreScriptGetPageReq, p *actions.DataPermission, list *[]models.LinePreScript, count *int64) error {
	var err error
	var data models.LinePreScript

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LinePreScriptService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LinePreScript对象
func (e *LinePreScript) Get(d *dto.LinePreScriptGetReq, p *actions.DataPermission, model *models.LinePreScript) error {
	var data models.LinePreScript

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLinePreScript error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LinePreScript对象
func (e *LinePreScript) Insert(c *dto.LinePreScriptInsertReq) error {
    var err error
    var data models.LinePreScript
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LinePreScriptService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LinePreScript对象
func (e *LinePreScript) Update(c *dto.LinePreScriptUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LinePreScript{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LinePreScriptService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LinePreScript
func (e *LinePreScript) Remove(d *dto.LinePreScriptDeleteReq, p *actions.DataPermission) error {
	var data models.LinePreScript

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLinePreScript error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
